#include "framebuffer.h"
#include "v3.h"
#include "math.h"
#include <iostream>
#include "scene.h"

FrameBuffer::FrameBuffer(int u0, int v0, 
  int _w, int _h) : Fl_Gl_Window(u0, v0, _w, _h, 0) {

  w = _w;
  h = _h;
  pix = new unsigned int[w*h];
  Set(0xFFFFFFFF);

}


void FrameBuffer::draw() {

    glDrawPixels(w, h, GL_RGBA, GL_UNSIGNED_BYTE, pix);

}

void FrameBuffer::Set(unsigned int color) {

  for (int i = 0; i < w*h; i++)
    pix[i] = color;

}

unsigned int FrameBuffer::Get(int u, int v) {

  return pix[(h-1-v)*w+u];

}

int FrameBuffer::handle(int event)  {  

  switch(event) 
  {   
  case FL_KEYBOARD: {
    KeyboardHandle();
    return 0;
  }
  default:
    break;
  }
  return 0;

}


void FrameBuffer::KeyboardHandle() {

  float tstep = 3.0f;
  float rstep = 3.0f;
  int key = Fl::event_key();
  switch (key) {
    case FL_Left: {
      break;
    }
    case FL_Right: {
      break;
    }
    default:
      cerr << "INFO: do not understand keypress" << endl;
  }
}
